Index: /trunk/LMDZ.COMMON/libf/evolution/reshape_XIOS_output.F90
===================================================================
--- /trunk/LMDZ.COMMON/libf/evolution/reshape_XIOS_output.F90	(revision 3075)
+++ /trunk/LMDZ.COMMON/libf/evolution/reshape_XIOS_output.F90	(revision 3076)
@@ -1,3 +1,3 @@
-program reshape_XIOS_output
+PROGRAM reshape_XIOS_output
 
 !=======================================================================
@@ -10,224 +10,193 @@
 ! Authors: RV & LL
 !=======================================================================
-    use netcdf
-    implicit none
-    integer :: status, ncid, ncid1, ncid2
-    integer :: nDims, nVars, nGlobalAtts, unlimDimID
-    integer i,j
-
-    integer :: include_parents
-
-    integer, dimension(:),allocatable :: dimids
-    integer, dimension(:),allocatable :: varids
-
-    integer, dimension(:),allocatable :: dimids_2
-    integer, dimension(:),allocatable :: varids_2
-
-    integer, dimension(:),allocatable :: dimid_var
-
-    real, dimension(:), allocatable :: tempvalues_1d
-    real, dimension(:), allocatable :: values_1d
-
-    real, dimension(:,:), allocatable :: tempvalues_2d
-    real, dimension(:,:), allocatable :: values_2d
-
-    real, dimension(:,:,:), allocatable :: tempvalues_3d
-    real, dimension(:,:,:), allocatable :: values_3d
-
-    real, dimension(:,:,:,:), allocatable :: tempvalues_4d
-    real, dimension(:,:,:,:), allocatable :: values_4d
-
-  character*1 str2
-  character*30 :: name_
-  character*30 :: namevar
-  integer  :: xtype_var
-  integer :: len_
-  integer :: len_1,len_2
-  integer :: len_lat, len_lon, len_time, len_soil
-  integer :: dimid_lon, dimid_lat, dimid_time, dimid_soil
-  integer :: dimid_2
-  integer :: numdims
-  integer :: numatts
-  integer :: numyear
-
-DO numyear=1, 2
-write(*,*) 'numyear',numyear
-write(str2(1:1),'(i1.1)') numyear
-!nf90_open                 ! open existing netCDF dataset
-!integer :: ncid, status
-!...
-status = nf90_open(path = "data2reshape"//str2//".nc", mode = nf90_nowrite, ncid = ncid1)
-if(status /= nf90_noerr) call handle_err(status)
-
-status = nf90_create(path = "datareshaped"//str2//".nc", cmode=or(nf90_noclobber,nf90_64bit_offset), ncid = ncid2)
-if(status /= nf90_noerr) call handle_err(status)
-
-status = nf90_inquire(ncid1, ndims, nvars, nglobalatts, unlimdimid)
-if(status /= nf90_noerr) call handle_err(status)
-
-allocate(dimids(ndims))
-allocate(varids(nvars))
-
-allocate(dimids_2(ndims))
-allocate(varids_2(nvars))
-
-status = nf90_inq_dimids(ncid1, ndims, dimids, include_parents)
-if(status /= nf90_noerr) call handle_err(status)
-status = nf90_inq_varids(ncid1, nvars, varids)
-if(status /= nf90_noerr) call handle_err(status)
-
-do i=1,ndims
-  status = nf90_inquire_dimension(ncid1, dimids(i), name_, len_)
-  if(status /= nf90_noerr) call handle_err(status)
-  if(name_.eq."lon" .or. name_.eq."longitude")  then
-     dimid_lon=dimids(i)
-     len_lon=len_
-     len_=len_+1
-  elseif(name_.eq."lat".or. name_.eq."latitude") then
-     dimid_lat=dimids(i)
-     len_lat=len_
-  elseif(name_.eq."time_counter".or. name_.eq. "Time") then
-     dimid_time=dimids(i)
-     len_time=len_
-  elseif(name_.eq."soil_layers".or. name_.eq. "subsurface_layers") then
-     dimid_soil=dimids(i)
-     len_soil=len_
-  endif
-  status = nf90_def_dim(ncid2, name_, len_, dimid_2)
-  if(status /= nf90_noerr) call handle_err(status)
-  dimids_2(i)=dimid_2
+use netcdf
+
+implicit none
+
+integer                               :: state, ncid, ncid1, ncid2, nDims, nVars, nGlobalAtts, unlimDimID
+integer                               :: i, j, include_parents
+integer, dimension(:),    allocatable :: dimids, varids, dimids_2, varids_2, dimid_var
+real, dimension(:),       allocatable :: tempvalues_1d, values_1d
+real, dimension(:,:),     allocatable :: tempvalues_2d, values_2d
+real, dimension(:,:,:),   allocatable :: tempvalues_3d, values_3d
+real, dimension(:,:,:,:), allocatable :: tempvalues_4d, values_4d
+character(1)                          :: str2
+character(30)                         :: name_, namevar
+integer                               :: xtype_var, len_, len_1, len_2, len_lat, len_lon, len_time, len_soil
+integer                               :: dimid_lon, dimid_lat, dimid_time, dimid_soil, dimid_2, numdims, numatts, numyear
+
+do numyear = 1,2
+    write(*,*) 'numyear',numyear
+    write(str2(1:1),'(i1.1)') numyear
+    !nf90_open                 ! open existing netCDF dataset
+    !integer :: ncid, state
+    !...
+    state = nf90_open(path = "data2reshape"//str2//".nc", mode = nf90_nowrite, ncid = ncid1)
+    if (state /= nf90_noerr) call handle_err(state)
+
+    state = nf90_create(path = "datareshaped"//str2//".nc", cmode=or(nf90_noclobber,nf90_64bit_offset), ncid = ncid2)
+    if (state /= nf90_noerr) call handle_err(state)
+
+    state = nf90_inquire(ncid1, ndims, nvars, nglobalatts, unlimdimid)
+    if (state /= nf90_noerr) call handle_err(state)
+
+    allocate(dimids(ndims))
+    allocate(varids(nvars))
+
+    allocate(dimids_2(ndims))
+    allocate(varids_2(nvars))
+
+    state = nf90_inq_dimids(ncid1, ndims, dimids, include_parents)
+    if (state /= nf90_noerr) call handle_err(state)
+    state = nf90_inq_varids(ncid1, nvars, varids)
+    if (state /= nf90_noerr) call handle_err(state)
+
+    do i = 1,ndims
+        state = nf90_inquire_dimension(ncid1, dimids(i), name_, len_)
+        if (state /= nf90_noerr) call handle_err(state)
+        if (name_ == "lon" .or. name_ == "longitude") then
+            dimid_lon = dimids(i)
+            len_lon = len_
+            len_ = len_ + 1
+        elseif (name_ == "lat".or. name_ == "latitude") then
+            dimid_lat=dimids(i)
+            len_lat=len_
+        elseif (name_ == "time_counter".or. name_ ==  "Time") then
+            dimid_time=dimids(i)
+            len_time=len_
+        elseif (name_ == "soil_layers".or. name_ ==  "subsurface_layers") then
+            dimid_soil=dimids(i)
+            len_soil = len_
+        endif
+        state = nf90_def_dim(ncid2, name_,len_,dimid_2)
+        if (state /= nf90_noerr) call handle_err(state)
+        dimids_2(i) = dimid_2
+    enddo
+
+    do i = 1,nvars
+        state = nf90_inquire_variable(ncid1, varids(i),name = namevar,xtype = xtype_var,ndims = numdims,natts = numatts)
+        write(*,*) "namevar00= ", namevar
+        if (state /= nf90_noerr) call handle_err(state)
+        allocate(dimid_var(numdims))
+        state = nf90_inquire_variable(ncid1,varids(i),name = namevar,xtype = xtype_var,ndims = numdims,dimids = dimid_var,natts = numatts)
+        if (state /= nf90_noerr) call handle_err(state)
+        if (numdims == 1) then
+            if (namevar == "lon") then
+                allocate(tempvalues_1d(len_lon))
+                allocate(values_1d(len_lon + 1))
+                state = nf90_get_var(ncid1,varids(i),tempvalues_1d)
+                if (state /= nf90_noerr) call handle_err(state)
+                state = nf90_def_var(ncid2,namevar,xtype_var, dimid_var, varids_2(i))
+                if (state /= nf90_noerr) call handle_err(state)
+                values_1d(1:len_lon) = tempvalues_1d(:)
+                values_1d(len_lon + 1) = values_1d(1)
+                state = nf90_enddef(ncid2)
+                if (state /= nf90_noerr) call handle_err(state)
+                state = nf90_put_var(ncid2, varids_2(i), values_1d)
+                if (state /= nf90_noerr) call handle_err(state)
+                state = nf90_redef(ncid2)
+                if (state /= nf90_noerr) call handle_err(state)
+                deallocate(tempvalues_1d)
+                deallocate(values_1d)
+            else
+                state = nf90_inquire_dimension(ncid1,dimid_var(1),name_,len_)
+                if (state /= nf90_noerr) call handle_err(state)
+                allocate(tempvalues_1d(len_))
+                state = nf90_get_var(ncid1,varids(i),tempvalues_1d)
+                if (state /= nf90_noerr) call handle_err(state)
+                state = nf90_def_var(ncid2,namevar,xtype_var,dimid_var,varids_2(i))
+                if (state /= nf90_noerr) call handle_err(state)
+                state = nf90_enddef(ncid2)
+                if (state /= nf90_noerr) call handle_err(state)
+                state = nf90_put_var(ncid2, varids_2(i), tempvalues_1d)
+                if (state /= nf90_noerr) call handle_err(state)
+                state = nf90_redef(ncid2)
+                if (state /= nf90_noerr) call handle_err(state)
+                deallocate(tempvalues_1d)
+            endif
+        else if (numdims == 2) then
+            if (namevar == "area") then
+                allocate(tempvalues_2d(len_lon,len_lat))
+                allocate(values_2d(len_lon + 1,len_lat))
+                state = nf90_get_var(ncid1,varids(i),tempvalues_2d)
+                if (state /= nf90_noerr) call handle_err(state)
+                state = nf90_def_var(ncid2,namevar,xtype_var,dimid_var,varids_2(i))
+                if (state /= nf90_noerr) call handle_err(state)
+                values_2d(1:len_lon,:) = tempvalues_2d(:,:)
+                values_2d(len_lon+1,:) = values_2d(1,:)
+                state = nf90_enddef(ncid2)
+                if (state /= nf90_noerr) call handle_err(state)
+                state = nf90_put_var(ncid2,varids_2(i),values_2d)
+                if (state /= nf90_noerr) call handle_err(state)
+                state = nf90_redef(ncid2)
+                if (state /= nf90_noerr) call handle_err(state)
+                deallocate(tempvalues_2d)
+                deallocate(values_2d)
+            else
+                state = nf90_inquire_dimension(ncid1,dimid_var(1),name_,len_1)
+                if (state /= nf90_noerr) call handle_err(state)
+                state = nf90_inquire_dimension(ncid1,dimid_var(2),name_,len_2)
+                if (state /= nf90_noerr) call handle_err(state)
+                allocate(tempvalues_2d(len_1,len_2))
+                state = nf90_get_var(ncid1, varids(i), tempvalues_2d)
+                if (state /= nf90_noerr) call handle_err(state)
+                state = nf90_def_var(ncid2,namevar,xtype_var,dimid_var,varids_2(i))
+                if (state /= nf90_noerr) call handle_err(state)
+                state = nf90_enddef(ncid2)
+                if (state /= nf90_noerr) call handle_err(state)
+                state = nf90_put_var(ncid2, varids_2(i), tempvalues_2d)
+                if (state /= nf90_noerr) call handle_err(state)
+                state = nf90_redef(ncid2)
+                if (state /= nf90_noerr) call handle_err(state)
+                deallocate(tempvalues_2d)
+            endif
+        elseif (numdims == 3) then
+            allocate(tempvalues_3d(len_lon,len_lat,len_time))
+            allocate(values_3d(len_lon + 1,len_lat,len_time))
+            state = nf90_get_var(ncid1,varids(i),tempvalues_3d)
+            if (state /= nf90_noerr) call handle_err(state)
+            state = nf90_def_var(ncid2,namevar,xtype_var,dimid_var,varids_2(i))
+            if (state /= nf90_noerr) call handle_err(state)
+            values_3d(1:len_lon,:,:) = tempvalues_3d(:,:,:)
+            values_3d(len_lon+1,:,:) = values_3d(1,:,:)
+            state = nf90_enddef(ncid2)
+            if (state /= nf90_noerr) call handle_err(state)
+            state = nf90_put_var(ncid2, varids_2(i), values_3d)
+            if (state /= nf90_noerr) call handle_err(state)
+            state = nf90_redef(ncid2)
+            if (state /= nf90_noerr) call handle_err(state)
+            deallocate(tempvalues_3d)
+            deallocate(values_3d)
+        else if (numdims == 4) then
+            allocate(tempvalues_4d(len_lon,len_lat,len_soil,len_time))
+            allocate(values_4d(len_lon+1,len_lat,len_soil,len_time))
+            state = nf90_get_var(ncid1, varids(i), tempvalues_4d)
+            if (state /= nf90_noerr) call handle_err(state)
+            state = nf90_def_var(ncid2, namevar, xtype_var, dimid_var, varids_2(i))
+            if (state /= nf90_noerr) call handle_err(state)
+            state = nf90_enddef(ncid2)
+            values_4d(1:len_lon,:,:,:) = tempvalues_4d(:,:,:,:)
+            values_4d(len_lon+1,:,:,:) = values_4d(1,:,:,:)
+            if (state /= nf90_noerr) call handle_err(state)
+            state = nf90_put_var(ncid2, varids_2(i), values_4d)
+            if (state /= nf90_noerr) call handle_err(state)
+            state = nf90_redef(ncid2)
+            if (state /= nf90_noerr) call handle_err(state)
+            deallocate(tempvalues_4d)
+            deallocate(values_4d)
+        endif
+        deallocate(dimid_var)
+    enddo
+
+    state = nf90_enddef(ncid2)
+    if (state /= nf90_noerr) call handle_err(state)
+    state = nf90_close(ncid1)
+    if (state /= nf90_noerr) call handle_err(state)
+    state = nf90_close(ncid2)
+    if (state /= nf90_noerr) call handle_err(state)
+
+    deallocate(dimids,varids,dimids_2,varids_2)
 enddo
 
-do i=1,nvars
-  status = nf90_inquire_variable(ncid1, varids(i), name=namevar, xtype=xtype_var, ndims = numdims,natts = numatts)
-  write(*,*) "namevar00= ", namevar
-  if(status /= nf90_noerr) call handle_err(status)
-  allocate(dimid_var(numdims))
-  status = nf90_inquire_variable(ncid1, varids(i), name=namevar, xtype=xtype_var, ndims = numdims, dimids=dimid_var, natts = numatts)
-  if(status /= nf90_noerr) call handle_err(status)
-  if(numdims.eq.1) then
-    if(namevar.eq."lon") then
-      allocate(tempvalues_1d(len_lon))
-      allocate(values_1d(len_lon+1))
-      status = nf90_get_var(ncid1, varids(i), tempvalues_1d)
-      if(status /= nf90_noerr) call handle_err(status)
-      status = nf90_def_var(ncid2, namevar, xtype_var, dimid_var, varids_2(i))
-      if(status /= nf90_noerr) call handle_err(status)
-      values_1d(1:len_lon)=tempvalues_1d(:)
-      values_1d(len_lon+1)=values_1d(1)
-      status = nf90_enddef(ncid2)
-      if(status /= nf90_noerr) call handle_err(status)
-      status = nf90_put_var(ncid2, varids_2(i), values_1d)
-      if(status /= nf90_noerr) call handle_err(status)
-      status = nf90_redef(ncid2)
-      if(status /= nf90_noerr) call handle_err(status)
-      deallocate(tempvalues_1d)
-      deallocate(values_1d)  
-    else
-      status = nf90_inquire_dimension(ncid1, dimid_var(1), name_, len_)
-      if(status /= nf90_noerr) call handle_err(status)
-      allocate(tempvalues_1d(len_))
-      status = nf90_get_var(ncid1, varids(i), tempvalues_1d)
-      if(status /= nf90_noerr) call handle_err(status)
-      status = nf90_def_var(ncid2, namevar, xtype_var, dimid_var, varids_2(i))
-      if(status /= nf90_noerr) call handle_err(status)
-      status = nf90_enddef(ncid2)
-      if(status /= nf90_noerr) call handle_err(status)
-      status = nf90_put_var(ncid2, varids_2(i), tempvalues_1d)  
-      if(status /= nf90_noerr) call handle_err(status) 
-      status = nf90_redef(ncid2)
-      if(status /= nf90_noerr) call handle_err(status)
-      deallocate(tempvalues_1d)    
-    endif
-  elseif(numdims.eq.2) then
-    if(namevar.eq."area") then
-      allocate(tempvalues_2d(len_lon,len_lat))
-      allocate(values_2d(len_lon+1,len_lat))     
-      status = nf90_get_var(ncid1, varids(i), tempvalues_2d)
-      if(status /= nf90_noerr) call handle_err(status)
-      status = nf90_def_var(ncid2, namevar, xtype_var, dimid_var, varids_2(i))
-      if(status /= nf90_noerr) call handle_err(status)
-      values_2d(1:len_lon,:)=tempvalues_2d(:,:)
-      values_2d(len_lon+1,:)=values_2d(1,:)
-      status = nf90_enddef(ncid2)
-      if(status /= nf90_noerr) call handle_err(status)
-      status = nf90_put_var(ncid2, varids_2(i), values_2d)   
-      if(status /= nf90_noerr) call handle_err(status)
-      status = nf90_redef(ncid2)
-      if(status /= nf90_noerr) call handle_err(status)
-      deallocate(tempvalues_2d)
-      deallocate(values_2d) 
-    else
-      status = nf90_inquire_dimension(ncid1, dimid_var(1), name_, len_1)
-      if(status /= nf90_noerr) call handle_err(status)
-      status = nf90_inquire_dimension(ncid1, dimid_var(2), name_, len_2)
-      if(status /= nf90_noerr) call handle_err(status)
-      allocate(tempvalues_2d(len_1,len_2))
-      status = nf90_get_var(ncid1, varids(i), tempvalues_2d)
-      if(status /= nf90_noerr) call handle_err(status)
-      status = nf90_def_var(ncid2, namevar, xtype_var, dimid_var, varids_2(i))
-      if(status /= nf90_noerr) call handle_err(status)
-      status = nf90_enddef(ncid2)
-      if(status /= nf90_noerr) call handle_err(status)
-      status = nf90_put_var(ncid2, varids_2(i), tempvalues_2d) 
-      if(status /= nf90_noerr) call handle_err(status) 
-      status = nf90_redef(ncid2)
-      if(status /= nf90_noerr) call handle_err(status)
-      deallocate(tempvalues_2d)
-    endif
-  elseif(numdims.eq.3) then
-      allocate(tempvalues_3d(len_lon,len_lat,len_time))
-      allocate(values_3d(len_lon+1,len_lat,len_time))
-      status = nf90_get_var(ncid1, varids(i), tempvalues_3d)
-      if(status /= nf90_noerr) call handle_err(status)
-      status = nf90_def_var(ncid2, namevar, xtype_var, dimid_var, varids_2(i))
-      if(status /= nf90_noerr) call handle_err(status)
-      values_3d(1:len_lon,:,:)=tempvalues_3d(:,:,:)
-      values_3d(len_lon+1,:,:)=values_3d(1,:,:)
-      status = nf90_enddef(ncid2)
-      if(status /= nf90_noerr) call handle_err(status)
-      status = nf90_put_var(ncid2, varids_2(i), values_3d)
-      if(status /= nf90_noerr) call handle_err(status)
-      status = nf90_redef(ncid2)
-      if(status /= nf90_noerr) call handle_err(status)
-      deallocate(tempvalues_3d)
-      deallocate(values_3d)
-  elseif(numdims.eq.4) then
-      allocate(tempvalues_4d(len_lon,len_lat,len_soil,len_time))
-      allocate(values_4d(len_lon+1,len_lat,len_soil,len_time))
-      status = nf90_get_var(ncid1, varids(i), tempvalues_4d)
-      if(status /= nf90_noerr) call handle_err(status)
-      status = nf90_def_var(ncid2, namevar, xtype_var, dimid_var, varids_2(i))
-      if(status /= nf90_noerr) call handle_err(status)
-      status = nf90_enddef(ncid2)
-      values_4d(1:len_lon,:,:,:)=tempvalues_4d(:,:,:,:)
-      values_4d(len_lon+1,:,:,:)=values_4d(1,:,:,:)
-      if(status /= nf90_noerr) call handle_err(status)
-      status = nf90_put_var(ncid2, varids_2(i), values_4d)
-      if(status /= nf90_noerr) call handle_err(status)
-      status = nf90_redef(ncid2)
-      if(status /= nf90_noerr) call handle_err(status)
-      deallocate(tempvalues_4d)
-      deallocate(values_4d)
-  endif
-
-  deallocate(dimid_var)
-enddo
-
-status = nf90_enddef(ncid2)
-if(status /= nf90_noerr) call handle_err(status)
-status = nf90_close(ncid1)
-if(status /= nf90_noerr) call handle_err(status)
-status = nf90_close(ncid2)
-if(status /= nf90_noerr) call handle_err(status)
-
-
-deallocate(dimids)
-deallocate(varids)
-deallocate(dimids_2)
-deallocate(varids_2)
-
-enddo
-
-end program reshape_XIOS_output
-
+END PROGRAM reshape_XIOS_output
+
Index: /trunk/LMDZ.COMMON/libf/evolution/soil_TIfeedback_PEM_mod.F90
===================================================================
--- /trunk/LMDZ.COMMON/libf/evolution/soil_TIfeedback_PEM_mod.F90	(revision 3076)
+++ /trunk/LMDZ.COMMON/libf/evolution/soil_TIfeedback_PEM_mod.F90	(revision 3076)
@@ -0,0 +1,98 @@
+MODULE soil_TIfeedback_PEM_mod
+
+implicit none
+
+!=======================================================================
+contains
+!=======================================================================
+
+SUBROUTINE soil_TIfeedback_PEM(ngrid,nsoil,icecover,newtherm_i)
+
+use comsoil_h_PEM, only: layer_PEM, inertiedat_PEM
+
+implicit none
+
+!=======================================================================
+!   Description :
+!       Surface water ice / Thermal inertia feedback.
+!
+!   When surface water-ice is thick enough, this routine creates a new
+!   soil thermal inertia with three different layers :
+!   - One layer of surface water ice (the thickness is given
+!     by the variable icecover (in kg of ice per m2) and the thermal
+!     inertia is prescribed by inert_h2o_ice (see surfdat_h));
+!   - A transitional layer of mixed thermal inertia;
+!   - A last layer of regolith below the ice cover whose thermal inertia
+!     is equal to inertiedat.
+!
+!  To use the model :
+!      SET THE tifeedback LOGICAL TO ".true." in callphys.def.
+!
+!  Author: Adapted from J.-B. Madeleine Mars 2008 ( Updated November 2012) by LL, 2022
+!=======================================================================
+
+!Inputs
+!------
+integer,                intent(in) :: ngrid    ! Number of horizontal grid points
+integer,                intent(in) :: nsoil    ! Number of soil layers
+real, dimension(ngrid), intent(in) :: icecover ! tracer on the surface (kg.m-2)
+!Outputs
+!-------
+real,intent(inout) :: newtherm_i(ngrid,nsoil)    ! New soil thermal inertia
+!Local variables
+!---------------
+integer :: ig                       ! Grid point (ngrid)
+integer :: ik                       ! Grid point (nsoil)
+integer :: iref                     ! Ice/Regolith boundary index
+real    :: icedepth                 ! Ice cover thickness (m)
+real    :: inert_h2o_ice = 800.     ! surface water ice thermal inertia [SI]
+real    :: rho_ice = 920.           ! density of water ice [kg/m^3]
+real    :: prev_thermi(ngrid,nsoil) ! previous thermal inertia [SI]
+
+prev_thermi(:,:) = newtherm_i(:,:)
+
+!Creating the new soil thermal inertia table
+!-------------------------------------------
+do ig = 1,ngrid
+    ! Calculating the ice cover thickness
+    icedepth = icecover(ig)/rho_ice
+
+    ! If the ice cover is too thick or watercaptag = true, the entire column is changed:
+    if (icedepth >= layer_PEM(nsoil)) then
+        do ik = 1,nsoil
+            newtherm_i(ig,ik) = max(inert_h2o_ice,prev_thermi(ig,ik))
+        enddo
+    ! We neglect the effect of a very thin ice cover:
+    else if (icedepth < layer_PEM(1)) then
+        do ik = 1,nsoil
+            newtherm_i(ig,ik) = inertiedat_PEM(ig,ik)
+        enddo
+    else
+        ! Ice/regolith boundary index:
+        iref = 1
+        ! Otherwise, we find the ice/regolith boundary:
+        do ik=1,nsoil-1
+            if ((icedepth >= layer_PEM(ik)) .and. (icedepth < layer_PEM(ik + 1))) then
+                iref = ik + 1
+                exit
+            endif
+        enddo
+        ! And we change the thermal inertia:
+        do ik = 1,iref - 1
+            newtherm_i(ig,ik) = max(inert_h2o_ice,prev_thermi(ig,ik))
+        enddo
+        ! Transition (based on the equations of thermal conduction):
+        newtherm_i(ig,iref) = sqrt((layer_PEM(iref) - layer_PEM(iref-1))/(((icedepth - layer_PEM(iref - 1))/newtherm_i(ig,iref - 1)**2) &
+                              + ((layer_PEM(iref) - icedepth)/inertiedat_PEM(ig,ik)**2) ) )
+        ! Underlying regolith:
+        do ik = iref + 1,nsoil
+            newtherm_i(ig,ik) = inertiedat_PEM(ig,ik)
+        enddo
+    endif ! icedepth
+enddo ! ig
+
+return
+
+END SUBROUTINE soil_TIfeedback_PEM
+
+END MODULE soil_TIfeedback_PEM_mod
Index: /trunk/LMDZ.COMMON/libf/evolution/soil_pem_compute_mod.F90
===================================================================
--- /trunk/LMDZ.COMMON/libf/evolution/soil_pem_compute_mod.F90	(revision 3076)
+++ /trunk/LMDZ.COMMON/libf/evolution/soil_pem_compute_mod.F90	(revision 3076)
@@ -0,0 +1,115 @@
+MODULE soil_pem_compute_mod
+
+implicit none
+
+!=======================================================================
+contains
+!=======================================================================
+
+SUBROUTINE soil_pem_compute(ngrid,nsoil,firstcall,therm_i,timestep,tsurf,tsoil)
+
+use comsoil_h_PEM, only: layer_PEM, mlayer_PEM, mthermdiff_PEM, thermdiff_PEM, coefq_PEM, coefd_PEM, mu_PEM, alph_PEM, beta_PEM, fluxgeo
+use comsoil_h,     only: volcapa
+
+implicit none
+
+!-----------------------------------------------------------------------
+!  Author: LL
+!  Purpose: Compute soil temperature using an implict 1st order scheme
+!  
+!  Note: depths of layers and mid-layers, soil thermal inertia and 
+!        heat capacity are commons in comsoil_PEM.h
+!-----------------------------------------------------------------------
+
+#include "dimensions.h"
+
+!-----------------------------------------------------------------------
+!  arguments
+!  ---------
+!  inputs:
+integer,                      intent(in) :: ngrid     ! number of (horizontal) grid-points 
+integer,                      intent(in) :: nsoil     ! number of soil layers  
+logical,                      intent(in) :: firstcall ! identifier for initialization call 
+real, dimension(ngrid,nsoil), intent(in) :: therm_i   ! thermal inertia [SI]
+real,                         intent(in) :: timestep  ! time step [s]
+real, dimension(ngrid),       intent(in) :: tsurf     ! surface temperature [K]
+ 
+! outputs:
+real, dimension(ngrid,nsoil), intent(inout) :: tsoil ! soil (mid-layer) temperature [K]
+! local variables:
+integer :: ig, ik    
+
+! 0. Initialisations and preprocessing step
+ if (firstcall) then
+! 0.1 Build mthermdiff_PEM(:), the mid-layer thermal diffusivities
+    do ig = 1,ngrid
+        do ik = 0,nsoil - 1
+            mthermdiff_PEM(ig,ik) = therm_i(ig,ik + 1)*therm_i(ig,ik + 1)/volcapa    
+        enddo
+    enddo
+
+! 0.2 Build thermdiff(:), the "interlayer" thermal diffusivities
+    do ig = 1,ngrid
+        do ik = 1,nsoil - 1
+            thermdiff_PEM(ig,ik) = ((layer_PEM(ik) - mlayer_PEM(ik - 1))*mthermdiff_PEM(ig,ik) &
+                                   + (mlayer_PEM(ik) - layer_PEM(ik))*mthermdiff_PEM(ig,ik - 1))/(mlayer_PEM(ik) - mlayer_PEM(ik - 1))
+        enddo
+    enddo
+
+! 0.3 Build coefficients mu_PEM, q_{k+1/2}, d_k, alph_PEMa_k and capcal
+    ! mu_PEM
+    mu_PEM = mlayer_PEM(0)/(mlayer_PEM(1) - mlayer_PEM(0))
+
+    ! q_{1/2}
+    coefq_PEM(0) = volcapa*layer_PEM(1)/timestep
+    ! q_{k+1/2}
+    do ik = 1,nsoil - 1
+        coefq_PEM(ik) = volcapa*(layer_PEM(ik + 1) - layer_PEM(ik))/timestep
+    enddo
+
+    do ig = 1,ngrid
+        ! d_k
+        do ik = 1,nsoil - 1
+            coefd_PEM(ig,ik) = thermdiff_PEM(ig,ik)/(mlayer_PEM(ik)-mlayer_PEM(ik - 1))
+        enddo
+
+        ! alph_PEM_{N-1}
+        alph_PEM(ig,nsoil - 1) = coefd_PEM(ig,nsoil-1)/(coefq_PEM(nsoil - 1) + coefd_PEM(ig,nsoil - 1))
+        ! alph_PEM_k
+        do ik = nsoil - 2,1,-1
+            alph_PEM(ig,ik) = coefd_PEM(ig,ik)/(coefq_PEM(ik) + coefd_PEM(ig,ik + 1)*(1. - alph_PEM(ig,ik + 1)) + coefd_PEM(ig,ik))
+        enddo
+      enddo ! of do ig=1,ngrid
+endif ! of if (firstcall)
+
+IF (.not. firstcall) THEN
+! 2. Compute soil temperatures
+! First layer:
+    do ig = 1,ngrid
+        tsoil(ig,1) = (tsurf(ig) + mu_PEM*beta_PEM(ig,1)*thermdiff_PEM(ig,1)/mthermdiff_PEM(ig,0))/ &
+                      (1. + mu_PEM*(1. - alph_PEM(ig,1))*thermdiff_PEM(ig,1)/mthermdiff_PEM(ig,0))
+
+! Other layers:
+        do ik = 1,nsoil - 1
+                tsoil(ig,ik + 1) = alph_PEM(ig,ik)*tsoil(ig,ik) + beta_PEM(ig,ik) 
+        enddo
+    enddo
+endif
+
+!  2. Compute beta_PEM coefficients (preprocessing for next time step)
+! Bottom layer, beta_PEM_{N-1}
+do ig = 1,ngrid
+    beta_PEM(ig,nsoil - 1) = coefq_PEM(nsoil - 1)*tsoil(ig,nsoil)/(coefq_PEM(nsoil - 1) + coefd_PEM(ig,nsoil - 1)) &
+                             + fluxgeo/(coefq_PEM(nsoil - 1) + coefd_PEM(ig,nsoil - 1))
+enddo
+! Other layers
+do ik = nsoil-2,1,-1
+    do ig = 1,ngrid
+        beta_PEM(ig,ik) = (coefq_PEM(ik)*tsoil(ig,ik + 1) + coefd_PEM(ig,ik + 1)*beta_PEM(ig,ik + 1))/ &
+                          (coefq_PEM(ik) + coefd_PEM(ig,ik + 1)*(1. - alph_PEM(ig,ik + 1)) + coefd_PEM(ig,ik))
+    enddo
+enddo
+
+END SUBROUTINE soil_pem_compute
+
+END MODULE soil_pem_compute_mod
Index: /trunk/LMDZ.COMMON/libf/evolution/soil_pem_ini_mod.F90
===================================================================
--- /trunk/LMDZ.COMMON/libf/evolution/soil_pem_ini_mod.F90	(revision 3076)
+++ /trunk/LMDZ.COMMON/libf/evolution/soil_pem_ini_mod.F90	(revision 3076)
@@ -0,0 +1,108 @@
+MODULE soil_pem_ini_mod
+
+implicit none
+
+!=======================================================================
+contains
+!=======================================================================
+
+SUBROUTINE soil_pem_ini(ngrid,nsoil,therm_i,tsurf,tsoil)
+
+use comsoil_h_PEM, only: layer_PEM, mlayer_PEM, mthermdiff_PEM, thermdiff_PEM, coefq_PEM, coefd_PEM, mu_PEM, alph_PEM, beta_PEM, fluxgeo
+use comsoil_h,     only: volcapa
+
+implicit none
+
+!-----------------------------------------------------------------------
+!  Author: LL
+!  Purpose: Compute soil temperature using an implict 1st order scheme, stationnary solution
+!
+!  Note: depths of layers and mid-layers, soil thermal inertia and
+!        heat capacity are commons in comsoil_PEM.h
+!-----------------------------------------------------------------------
+
+#include "dimensions.h"
+
+!-----------------------------------------------------------------------
+!  arguments
+!  ---------
+!  inputs:
+integer,                      intent(in) :: ngrid   ! number of (horizontal) grid-points
+integer,                      intent(in) :: nsoil   ! number of soil layers
+real, dimension(ngrid,nsoil), intent(in) :: therm_i ! thermal inertia [SI]
+real, dimension(ngrid),       intent(in) :: tsurf   ! surface temperature [K]
+
+! outputs:
+real, dimension(ngrid,nsoil), intent(inout) :: tsoil ! soil (mid-layer) temperature [K]
+! local variables:
+integer :: ig, ik, iloop
+
+! 0. Initialisations and preprocessing step
+! 0.1 Build mthermdiff_PEM(:), the mid-layer thermal diffusivities
+do ig = 1,ngrid
+    do ik = 0,nsoil - 1
+        mthermdiff_PEM(ig,ik) = therm_i(ig,ik + 1)*therm_i(ig,ik + 1)/volcapa
+    enddo
+enddo
+
+! 0.2 Build thermdiff(:), the "interlayer" thermal diffusivities
+do ig = 1,ngrid
+    do ik = 1,nsoil - 1
+        thermdiff_PEM(ig,ik) = ((layer_PEM(ik) - mlayer_PEM(ik - 1))*mthermdiff_PEM(ig,ik) &
+                             + (mlayer_PEM(ik) - layer_PEM(ik))*mthermdiff_PEM(ig,ik - 1))/(mlayer_PEM(ik) - mlayer_PEM(ik - 1))
+    enddo
+enddo
+
+! 0.3 Build coefficients mu_PEM, q_{k+1/2}, d_k, alph_PEMa_k and capcal
+! mu_PEM
+mu_PEM = mlayer_PEM(0)/(mlayer_PEM(1) - mlayer_PEM(0))
+
+! q_{1/2}
+coefq_PEM(:) = 0.
+! q_{k+1/2}
+
+do ig = 1,ngrid
+    ! d_k
+    do ik = 1,nsoil-1
+        coefd_PEM(ig,ik) = thermdiff_PEM(ig,ik)/(mlayer_PEM(ik) - mlayer_PEM(ik - 1))
+    enddo
+
+    ! alph_PEM_{N-1}
+    alph_PEM(ig,nsoil - 1) = coefd_PEM(ig,nsoil - 1)/(coefq_PEM(nsoil - 1) + coefd_PEM(ig,nsoil - 1))
+    ! alph_PEM_k
+    do ik = nsoil - 2,1,-1
+        alph_PEM(ig,ik) = coefd_PEM(ig,ik)/(coefq_PEM(ik) + coefd_PEM(ig,ik + 1)*(1. - alph_PEM(ig,ik + 1)) + coefd_PEM(ig,ik))
+    enddo
+enddo ! of do ig=1,ngrid
+
+!  1. Compute beta_PEM coefficients
+! Bottom layer, beta_PEM_{N-1}
+do ig = 1,ngrid
+        beta_PEM(ig,nsoil - 1) = coefq_PEM(nsoil - 1)*tsoil(ig,nsoil)/(coefq_PEM(nsoil - 1) + coefd_PEM(ig,nsoil - 1)) &
+                                 + fluxgeo/(coefq_PEM(nsoil - 1) + coefd_PEM(ig,nsoil - 1))
+enddo
+! Other layers
+do ik = nsoil - 2,1,-1
+    do ig = 1,ngrid
+        beta_PEM(ig,ik) = (coefq_PEM(ik)*tsoil(ig,ik + 1) + coefd_PEM(ig,ik+1)*beta_PEM(ig,ik + 1))/ &
+                          (coefq_PEM(ik) + coefd_PEM(ig,ik + 1)*(1. - alph_PEM(ig,ik + 1)) + coefd_PEM(ig,ik))
+    enddo
+enddo
+
+!  2. Compute soil temperatures
+do iloop = 1,10 !just convergence
+    ! First layer:
+    do ig = 1,ngrid
+        tsoil(ig,1)=(tsurf(ig) + mu_PEM*beta_PEM(ig,1)*thermdiff_PEM(ig,1)/mthermdiff_PEM(ig,0))/ &
+                   (1. + mu_PEM*(1. - alph_PEM(ig,1))*thermdiff_PEM(ig,1)/mthermdiff_PEM(ig,0))
+    ! Other layers:
+    do ik = 1,nsoil - 1
+        tsoil(ig,ik + 1) = alph_PEM(ig,ik)*tsoil(ig,ik) + beta_PEM(ig,ik)
+    enddo
+enddo
+
+enddo ! iloop
+
+END SUBROUTINE soil_pem_ini
+
+END MODULE soil_pem_ini_mod
